<template>
  <div class="cruds_index">
  	<div class="cruds_reception">CRUDS da Trilha</div>

	  <div class="trilhas_list list"> 
      <div class="list_title"> Trilhas </div>
      <trilha-detail v-for="trilha of trilhas" 
        :key="trilha.id_trilha"
        :trilha="trilha"
      />
    </div>

	  <div class="modulos_list list"> 
      <div class="list_title"> Modulos </div>
      <modulo-detail v-for="modulo of modulos"
        :key="modulo.id_modulo"
        :modulo="modulo"
      />
    </div>

	  <div class="optativas_list list"> 
      <div class="list_title"> Optativas </div>
      <optativa-detail v-for="optativa of optativas"
        :key="optativa.id_disciplina"
        :optativa="optativa"
      />
    </div>

  </div>
</template>

<script>
import OptativaDetail from '@/components/OptativaDetail.vue'
import ModuloDetail from '@/components/ModuloDetail.vue'
import TrilhaDetail from '@/components/TrilhaDetail.vue'

export default {
  components: {
    OptativaDetail,
    ModuloDetail,
    TrilhaDetail
  },

  data() {
    return {
      trilhas: [],
      modulos: [],
      optativas: []
    }
  },

  async asyncData({app}) {
    const modulos = await app.$axios.$get("/modulos")

    const optativas = [];
    for (let modulo of modulos) {
      optativas.push(
        ...await app.$axios.$post("/rpc/modulo_disciplina", {
          id_modulo: modulo.id_modulo
        }));
    }

    return {
      trilhas: await app.$axios.$get("/trilhas"),
      modulos,
      optativas
    }
  }
}
</script>

<style lang="scss">
.cruds_index {
  background: $medium-color;

  align-self: stretch;
  height: 100%;
}

.list {
  display: flex;
  flex-flow: column nowrap;
  background: $light-color;
  margin: 1em 1em;
  padding: 0.5em;
  border-radius: 0.5em;
}

.list-item {
  display: flex;
  flex-flow: row nowrap;
  justify-content: space-around;
  align-items: center;
  margin-bottom: 1em;
  color: $primary-color;
}

.cruds_reception {
  color: $primary-color;
  margin: 1rem;
  font-size: 2em;
  font-weight: bold;
}

.list_title {
  color: $primary-color;
}
</style>
